<?php
/**
 * Created by PhpStorm.
 * User: zilongs
 * Date: 20-10-4
 * Time: 下午8:32
 */

namespace App\Http\Controllers\Api\V1;

use App\Models\Vaccine;

class VaccineController extends AuthController
{
    public function vaccineList()
    {
        $req = request()->post();
        $this->validate(request(), [
            'organization_id' => 'required|integer',
            'name' => 'max:50',
            'type' => 'in:0,1,2',
            'sort_type' => 'in:0,1,2',
        ]);

        $builder = Vaccine::select(['id', 'type', 'price', 'name', 'remark', 'supplier', 'stock'])->where('stock', '>', 0)->where('org_id', $req['organization_id']);
        if (!empty($req['type'])) {
            $builder->where('type', $req['type']);
        }
        if (!empty($req['name'])) {
            $builder->where('name', 'like', '%'.$req['name'].'%');
        }
        if (!empty($req['sort_type'])) {
            if ($req['sort_type'] == 1) {
                $builder->orderBy('price', 'asc');
            }
            elseif ($req['sort_type'] == 2) {
                $builder->orderBy('price', 'desc');
            }
        }

        $data = $builder->paginate();

        return out($data);
    }
}
